import { j as l } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as Ne, useState as J, useMemo as g, useRef as P, useEffect as Me, useCallback as ke } from "react";
import { isMobile as M } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as ze, Table as A, Skeleton as Le } from "antd";
import We from "../../../node_modules/classnames/index.mjs";
import He from "../../BitzDrawer/index.mjs";
import Pe from "../../BitzPagination/index.mjs";
import Ae from "../../BitzNoData/index.mjs";
import "../../BitzList/index.less.mjs";
import Se from "../../BitzList/List.mjs";
import "../../BitzPullRefresh/style/index.less.mjs";
import Ee from "../../BitzPullRefresh/PullRefresh.mjs";
import Oe, { TableContext as Ve } from "../Store/index.mjs";
import _e from "../TableSkeleton/index.mjs";
import { columnSort as Q, genColumnKey as Y } from "../Store/utils/index.mjs";
import S from "../../../node_modules/ahooks/es/useSize/index.mjs";
import $e from "../ActionCol/style.mjs";
import "./index.less.mjs";
import De from "../../../node_modules/lodash-es/at.mjs";
function Ke({
  showPagination: B = !0,
  fillEvenRow: E = !0,
  evenRowBgColor: Re = "#f9f9f9",
  height: w,
  dataSource: a = [],
  total: k = 0,
  columns: u,
  loading: j = !1,
  skeletonNum: Z = 2,
  skeletonRender: O,
  skeletonRowNum: I = 4,
  skeletonRowsWidth: ee = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: oe,
  mobileRefreshEmit: V,
  operationFilter: z,
  enableControlPage: le,
  pagination: re,
  paginationEmit: te = () => {
  },
  mobilePageHeight: qe = 500,
  mobileCancelText: ne = "取消",
  noDataTitle: se,
  noDataImg: ae,
  color: Ge,
  size: _,
  showTableTool: ie = !0,
  tableAction: ce,
  tableToolbar: he,
  selectionBar: de,
  scroll: h,
  resetPage: fe,
  ...d
}) {
  var X;
  const { token: c } = ze.useToken(), { gap: be } = $e(), f = Ne(Ve), [xe, L] = J(!1), ge = g(() => !!(a != null && a.length) && (a == null ? void 0 : a.length) >= k, [a, k]), [ue, Ce] = J([]), pe = (e, o) => {
    var r;
    const t = (r = z == null ? void 0 : z(e, o)) == null ? void 0 : r.filter(
      (n) => n.type !== "divider"
    );
    t != null && t.length && (Ce(t), L(!0));
  }, $ = () => {
    L(!1);
  }, ye = (e) => {
    var o;
    L(!1), (o = e.onClick) == null || o.call(e);
  }, C = P(null), p = S(C), T = P(null), W = S(T), D = P(null), y = S(D), we = () => {
    var t;
    const e = (t = T.current) == null ? void 0 : t.querySelectorAll(
      ".ant-table-body tr:not(.ant-table-measure-row)"
    ), o = [];
    if (e == null || e.forEach((r) => {
      var n;
      o.push(
        ((n = r.querySelector(".operationCol .actionGroup")) == null ? void 0 : n.clientWidth) || 0
      );
    }), o.length)
      return Math.ceil(Math.max(...o)) + be * 2;
  }, K = () => {
    var n;
    const e = (n = T.current) == null ? void 0 : n.querySelector(
      ".ant-table-body"
    ), o = e == null ? void 0 : e.clientWidth, t = ((e == null ? void 0 : e.offsetWidth) || 0) - o, r = t > 0;
    return { tbodyWidth: o, scrollBarWidth: t, hasScrollBar: r };
  }, me = (e) => {
    const o = e.length, t = e.filter((x) => x.width), n = t.map((x) => x.width).reduce((x, ve) => x + ve, 0);
    let s = 0;
    if (C.current) {
      const x = window.getComputedStyle(C.current);
      s = parseInt(x.getPropertyValue("--toolCell-width"));
    }
    let i = 0;
    d.rowSelection && (i += s), d.expandable && (i += s);
    const { tbodyWidth: N } = K(), b = parseInt(`${v.x}`) || 0, Te = Math.max(b, N), F = (parseInt(`${Te}`) || 0) - n - i;
    return F >= 0 ? F / (o - t.length) : void 0;
  }, { y: H, hasScrollBar: R } = g(() => {
    if (typeof w > "u")
      return {};
    const { hasScrollBar: e } = K();
    let o = 40, t = 40, r = 10;
    if (C.current) {
      const b = window.getComputedStyle(C.current);
      o = parseInt(b.getPropertyValue("--cell-block")), t = parseInt(b.getPropertyValue("--toolbar-height")), r = parseInt(b.getPropertyValue("--container-gap")) || 0;
    }
    const n = (y == null ? void 0 : y.height) || 0, s = n ? r : 0;
    return { y: w - n - s - t - o, hasScrollBar: e };
  }, [
    w,
    y == null ? void 0 : y.height,
    p == null ? void 0 : p.height,
    W == null ? void 0 : W.height
  ]), v = g(() => h != null && h.x ? { x: h.x, y: h.y || H } : h != null && h.y ? { x: 1e3, y: h.y } : { x: 1e3, y: H }, [h, H]), m = g(() => {
    const e = (s) => s.map((i) => {
      const N = Y(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), b = f.columnsMap[N];
      return b && b.show === !1 ? !1 : i.children ? {
        ...i,
        children: e(i.children)
      } : i;
    }).filter(Boolean), o = e(u);
    if (M)
      return o.sort(Q(f.columnsMap));
    const t = o.sort(Q(f.columnsMap)), r = me(t), n = t.map((s) => ({
      ...s,
      ...s.width ? {
        width: s.useMaxWidth ? we() ?? s.width : s.width
      } : {
        // 给未设置width的列设置平均数
        width: r
      }
    }));
    return [A.SELECTION_COLUMN, A.EXPAND_COLUMN, ...n];
  }, [
    f.columnsMap,
    u,
    M,
    v.x,
    d.rowSelection,
    d.expandable,
    p == null ? void 0 : p.height
  ]);
  Me(() => {
    if (u && u.length > 0) {
      const e = u.map(
        (o) => (
          // @ts-ignore
          Y((o == null ? void 0 : o.key) ?? (o == null ? void 0 : o.dataIndex), o == null ? void 0 : o.dataIndex)
        )
      );
      f.setSortKeyColumns(e);
    }
  }, [u]);
  const q = g(() => `${_ ?? (f == null ? void 0 : f.tableSize) ?? "lg"}BitzTable`, [_, f.tableSize]), Be = g(() => We(
    "bitzTableContainer",
    /* "hideBorder", */
    { hasScrollBar: R },
    q
  ), [q, R]), je = g(() => {
    var e, o, t, r, n, s;
    return {
      height: w,
      "--toolbar-bgColor": (e = c.Table) == null ? void 0 : e.toolbarBgColor,
      "--thead-bgColor": (o = c.Table) == null ? void 0 : o.headerBg,
      "--thead-hoverBgColor": (t = c.Table) == null ? void 0 : t.theadHoverBgColor,
      "--evenRow-BgColor": (r = c.Table) == null ? void 0 : r.evenRowBgColor,
      "--expandIcon-borderColor": (n = c.Table) == null ? void 0 : n.expandIconBorderColor,
      "--rowHover-bgColor": (s = c.Table) == null ? void 0 : s.rowHoverBg
      // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
    };
  }, [w]), G = ke(
    (e, o) => E ? o % 2 === 0 ? "oddRow" : "evenRow" : "",
    [E]
  ), U = /* @__PURE__ */ l.jsx(
    Se,
    {
      finished: ge,
      onLoad: oe,
      loadingText: "加载中...",
      finishedText: "没有更多了",
      errorText: "加载失败",
      children: /* @__PURE__ */ l.jsxs(
        "div",
        {
          className: "mobileList",
          style: { backgroundColor: (X = c.Table) == null ? void 0 : X.mobileListBgColor },
          children: [
            a == null ? void 0 : a.map((e, o) => {
              var t;
              return /* @__PURE__ */ l.jsx(
                "div",
                {
                  className: "listItem",
                  style: { backgroundColor: (t = c.Table) == null ? void 0 : t.listItemBgColor },
                  onClick: () => pe(e, o),
                  children: m == null ? void 0 : m.map((r, n) => {
                    var s;
                    return !(r != null && r.mobileHide) && /* @__PURE__ */ l.jsxs(
                      "div",
                      {
                        className: "row",
                        style: { color: c.colorText },
                        children: [
                          !r.mobileHideLabel && /* @__PURE__ */ l.jsxs("div", { className: "label", children: [
                            `${r.title}`,
                            "："
                          ] }),
                          /* @__PURE__ */ l.jsx("div", { className: "value", children: ((s = r == null ? void 0 : r.render) == null ? void 0 : s.call(
                            r,
                            De(e, (r == null ? void 0 : r.dataIndex) || ""),
                            e,
                            o
                          )) || (e == null ? void 0 : e[r.dataIndex]) })
                        ]
                      },
                      n
                    );
                  })
                },
                o
              );
            }),
            j && Array.from({ length: Z }).map((e, o) => {
              var t;
              return /* @__PURE__ */ l.jsx(
                "div",
                {
                  className: "listItem",
                  style: { backgroundColor: (t = c.Table) == null ? void 0 : t.listItemBgColor },
                  children: /* @__PURE__ */ l.jsx("div", { className: "row", children: O ? O() : /* @__PURE__ */ l.jsx(
                    Le,
                    {
                      title: !1,
                      paragraph: {
                        rows: I,
                        width: ee
                      },
                      active: !0
                    }
                  ) })
                },
                o
              );
            })
          ]
        }
      )
    }
  );
  return /* @__PURE__ */ l.jsxs("div", { className: "bitzTableBlock", children: [
    !M && /* @__PURE__ */ l.jsxs("div", { ref: C, className: Be, style: je, children: [
      /* @__PURE__ */ l.jsxs("div", { className: "bitzTableContainerBody", ref: T, children: [
        ie && /* @__PURE__ */ l.jsxs("div", { className: "bitzTableToolbarBlock", children: [
          ce || /* @__PURE__ */ l.jsx("div", {}),
          he,
          (d == null ? void 0 : d.rowSelection) && /* @__PURE__ */ l.jsx(l.Fragment, { children: de })
        ] }),
        /* @__PURE__ */ l.jsx(
          A,
          {
            columns: m,
            dataSource: a,
            loading: !1,
            pagination: !1,
            scroll: v,
            ...d,
            rowClassName: G
          }
        ),
        /* @__PURE__ */ l.jsx(
          _e,
          {
            columns: m,
            dataLength: a.length,
            scroll: v,
            rowSelection: d.rowSelection,
            expandable: d.expandable,
            rowClassName: G,
            loading: j
          }
        )
      ] }),
      B && /* @__PURE__ */ l.jsx(
        Pe,
        {
          elRefInstance: D,
          enableControl: le,
          pagination: re,
          total: k,
          dataSource: a,
          resetPage: fe,
          paginationEmit: te
        }
      )
    ] }),
    M && /* @__PURE__ */ l.jsxs(l.Fragment, { children: [
      (j || (a == null ? void 0 : a.length) > 0) && /* @__PURE__ */ l.jsx(l.Fragment, { children: V ? /* @__PURE__ */ l.jsx(Ee, { onRefresh: V, children: U }) : U }),
      !j && /* @__PURE__ */ l.jsx(Ae, { data: a, title: se, img: ae }),
      /* @__PURE__ */ l.jsx(
        He,
        {
          className: "tableMobileDrawer",
          open: xe,
          placement: "bottom",
          height: "auto",
          closable: !1,
          onClose: $,
          children: /* @__PURE__ */ l.jsxs("div", { className: "drawerBox", children: [
            /* @__PURE__ */ l.jsx("div", { className: "boxBody", children: ue.map((e, o) => /* @__PURE__ */ l.jsx(
              "div",
              {
                className: "operaList",
                onClick: () => ye(e),
                ...e.danger && {
                  style: { color: c.colorError }
                },
                children: e.label
              },
              o
            )) }),
            /* @__PURE__ */ l.jsx("div", { className: "boxLine" }),
            /* @__PURE__ */ l.jsx("div", { className: "boxFooter", onClick: $, children: ne })
          ] })
        }
      )
    ] })
  ] });
}
const fo = (B) => (
  // @ts-ignore
  /* @__PURE__ */ l.jsx(Oe, { initValue: B, children: /* @__PURE__ */ l.jsx(Ke, { ...B }) })
);
export {
  fo as default
};
