import { j as s } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as Q, useModal as U, antdModalV5 as X } from "@ebay/nice-modal-react";
import { Modal as Y, Checkbox as Z, Button as $ } from "antd";
import a from "./index.module.less.mjs";
import { useState as E, useContext as L, useEffect as ee, useCallback as B, useMemo as S } from "react";
import { TableContext as se } from "../../Store/index.mjs";
import { genColumnKey as H, columnSort as oe } from "../../Store/utils/index.mjs";
import u from "../../../../node_modules/classnames/index.mjs";
import { DndContext as te } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as le, verticalListSortingStrategy as ne, arrayMove as ae } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import ce from "./DndItem.mjs";
import { restrictToVerticalAxis as ie, restrictToWindowEdges as me } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import T from "../../../BitzButton/index.mjs";
import "./index.less.mjs";
import { useImmer as re } from "../../../../node_modules/use-immer/dist/use-immer.module.mjs";
import R from "../../../../node_modules/lodash-es/omit.mjs";
import de from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import ue from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
const _e = Q(() => {
  var w;
  const h = U(), [b, C] = E(null), [z, k] = E(!1), [c, x] = re({
    columnsMap: {},
    sortKeyColumns: []
  }), {
    persistenceType: A,
    persistenceKey: v,
    onlineChange: f,
    columnsMap: O,
    setColumnsMap: V,
    sortKeyColumns: F,
    setSortKeyColumns: W,
    // clearPersistenceStorage,
    ...l
  } = L(se);
  ee(() => {
    x((e) => {
      e.columnsMap = { ...O }, e.sortKeyColumns = [...F];
    });
  }, []);
  const q = B(() => {
    x((e) => {
      e.columnsMap = { ...l.defaultColumnKeyMap };
    });
  }, []), p = S(() => {
    var o, n;
    const e = [];
    return (o = l == null ? void 0 : l.columns) != null && o.length && ((n = l == null ? void 0 : l.columns) == null || n.map(({ key: d, dataIndex: t, ...m }) => {
      const y = H(
        d || t,
        [d || t].filter(Boolean).join("-")
      ), r = c.columnsMap[y || "null"];
      return (r == null ? void 0 : r.show) !== !1 && e.push({
        key: y,
        ...R(m, ["className"]),
        selectable: !1,
        disabled: (r == null ? void 0 : r.disable) === !0
      }), r;
    })), e.sort(oe(c.columnsMap));
  }, [c.columnsMap, l == null ? void 0 : l.columns]), j = B(
    (e) => {
      var o;
      return (o = c.sortKeyColumns) == null ? void 0 : o.findIndex((n) => n === e);
    },
    [c.sortKeyColumns]
  ), N = S(
    () => b ? j(b) : -1,
    [b, j]
  ), g = S(() => {
    const e = [], o = /* @__PURE__ */ new Map();
    return { list: ((d, t) => d.map(({ key: m, dataIndex: y, children: r, ...D }) => {
      var _;
      const M = H(
        m || y,
        [t == null ? void 0 : t.columnKey, D.index].filter(Boolean).join("-")
      ), i = c.columnsMap[M || "null"] || { show: !0 };
      (i == null ? void 0 : i.show) !== !1 && !r && e.push(M);
      const I = {
        key: M,
        ...R(D, ["className"]),
        selectable: !1,
        disabled: i.disable === !0,
        disableCheckbox: typeof i.disable == "boolean" ? i == null ? void 0 : i.disable : (_ = i == null ? void 0 : i.disable) == null ? void 0 : _.checkbox,
        isLeaf: t ? !0 : void 0
      };
      return o.set(m, I), I;
    }))(l == null ? void 0 : l.columns), keys: e, map: o };
  }, [c.columnsMap, l == null ? void 0 : l.columns]), G = (e, o) => {
    const n = { ...c.columnsMap };
    ((t) => {
      const m = { ...n[t] };
      m.show = !e, n[t] = m;
    })(o.key), k(!0), x((t) => {
      t.columnsMap = { ...n };
    });
  }, J = (e, o) => {
    const n = { ...c.columnsMap }, d = ae(c.sortKeyColumns, e, o);
    d.forEach((t, m) => {
      n[t] = { ...n[t] || {}, order: m };
    }), k(!0), x((t) => {
      t.columnsMap = { ...n }, t.sortKeyColumns = d;
    });
  }, P = () => {
    V(c.columnsMap), W(c.sortKeyColumns), A === "online" && v && (f == null || f(v, c.columnsMap)), h.resolve({ ...c.columnsMap }), h.hide();
  }, K = () => {
    h.hide();
  };
  return /* @__PURE__ */ s.jsxs(
    Y,
    {
      className: "tableColumnSettingModal",
      title: "自定义列",
      ...X(h),
      styles: { body: { maxHeight: window.innerHeight - 300 } },
      width: 600,
      onCancel: K,
      footer: /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
        /* @__PURE__ */ s.jsx(
          T,
          {
            type: "primary",
            icon: /* @__PURE__ */ s.jsx(de, {}),
            onClick: P,
            disabled: !z,
            children: "保存"
          }
        ),
        /* @__PURE__ */ s.jsx(T, { onClick: K, children: "取消" })
      ] }),
      children: [
        /* @__PURE__ */ s.jsx("div", { className: u(a.introduce, "tableColumnSetting_introduce"), children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ s.jsxs(
          "div",
          {
            className: u(a.container, "tableColumnSetting_container"),
            style: { maxHeight: window.innerHeight - 390, overflow: "auto" },
            children: [
              /* @__PURE__ */ s.jsxs("div", { className: a.block, children: [
                /* @__PURE__ */ s.jsxs("div", { className: u(a.header, "tableColumnSetting_header"), children: [
                  /* @__PURE__ */ s.jsx("div", { className: u(a.title, "tableColumnSetting_title"), children: "可用列" }),
                  /* @__PURE__ */ s.jsx("div", {})
                ] }),
                /* @__PURE__ */ s.jsx("div", { className: u(a.body, "tableColumnSetting_body"), children: /* @__PURE__ */ s.jsx("ul", { className: a.content, children: (w = g.list) == null ? void 0 : w.map((e) => {
                  const o = g.keys.includes(e.key);
                  return /* @__PURE__ */ s.jsxs(
                    "li",
                    {
                      className: u(a.item, {
                        [a.checked]: !o,
                        tableColumnSetting_checked: !o
                      }),
                      onClick: () => !e.disabled && G(o, e),
                      children: [
                        /* @__PURE__ */ s.jsx(Z, { checked: o, disabled: e.disabled }),
                        /* @__PURE__ */ s.jsx(
                          "span",
                          {
                            className: u(
                              a["content-item-text"],
                              "tableColumnSetting_content-item-text"
                            ),
                            children: e.title
                          }
                        )
                      ]
                    },
                    e.key
                  );
                }) }) })
              ] }),
              /* @__PURE__ */ s.jsxs("div", { className: a.block, children: [
                /* @__PURE__ */ s.jsxs("div", { className: a.header, children: [
                  /* @__PURE__ */ s.jsx("div", { className: a.title, children: "选定列" }),
                  /* @__PURE__ */ s.jsx(
                    $,
                    {
                      type: "link",
                      icon: /* @__PURE__ */ s.jsx(ue, {}),
                      size: "small",
                      onClick: q,
                      children: "重置"
                    }
                  )
                ] }),
                /* @__PURE__ */ s.jsx("div", { className: u(a.body, "tableColumnSetting_body-order"), children: /* @__PURE__ */ s.jsx(
                  te,
                  {
                    modifiers: [ie, me],
                    onDragStart: (e) => {
                      const { active: o } = e;
                      o && C(o == null ? void 0 : o.id);
                    },
                    onDragCancel: () => C(null),
                    onDragEnd: (e) => {
                      C(null);
                      const { over: o } = e;
                      if (o) {
                        const n = j(o.id);
                        N !== n && J(N, n);
                      }
                    },
                    children: /* @__PURE__ */ s.jsx(
                      le,
                      {
                        items: p == null ? void 0 : p.map((e) => e.key),
                        strategy: ne,
                        children: /* @__PURE__ */ s.jsx("ul", { className: a.content, children: p == null ? void 0 : p.map((e) => /* @__PURE__ */ s.jsx(ce, { item: e }, e.key)) })
                      }
                    )
                  }
                ) })
              ] })
            ]
          }
        )
      ]
    }
  );
});
export {
  _e as default
};
